package net.projectmonkey.object.mapper.analysis.duplicates;

/*
 *
 *  * Copyright 2012 the original author or authors.
 *  *
 *  * Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  *      http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  * limitations under the License.
 *
 */

import net.projectmonkey.object.mapper.analysis.result.PropertyPath;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Andy Moody
 */
public class PropertyPathAndTopLevelParent extends PropertyPathAndTokens
{

	private PropertyPath topLevelPath;

	public PropertyPathAndTopLevelParent(final PropertyPath topLevelPath, final PropertyPath currentPath, final List<List<String>> tokens)
	{
		super(currentPath, tokens);
		this.topLevelPath = topLevelPath;
	}

	public PropertyPath getTopLevelPath()
	{
		return topLevelPath;
	}

	public List<PropertyPath> createIntermediatePaths()
	{
		List<PropertyPath> intermediateMappings = new ArrayList<PropertyPath>();
		PropertyPath currentPath = getPath();
		while(currentPath != null && currentPath != getTopLevelPath())
		{
			currentPath = currentPath.getParent();
			if(currentPath != null)
			{
				intermediateMappings.add(0, currentPath);
			}
		}
		return intermediateMappings;
	}

}
