package net.projectmonkey.object.mapper.analysis.matching;

/*
 *
 *  * Copyright 2012 the original author or authors.
 *  *
 *  * Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  *      http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  * limitations under the License.
 *
 */

/**
 * @author Andy Moody
 */
public class MatchingStrategies
{

	/**
	 * Matching strategy which allows flattening / expanding of properties but
	 * still requires that all tokens are matched in order.
	 * This strategy does ignore property case.
	 */
	public static final MatchingStrategy FLATTENING = FlatteningMatchingStrategy.INSTANCE;


	/**
	 * Matching strategy which will only match properties with the exact same structure.
	 * This strategy does not ignore case.
	 */
	public static final MatchingStrategy EXACT = ExactMatchingStrategy.INSTANCE;

}
