package net.projectmonkey.object.mapper.analysis.token.matcher;

import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;

/**
 * @author Andy Moody
 */
/*
 *
 *  * Copyright 2012 the original author or authors.
 *  *
 *  * Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  *      http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  * limitations under the License.
 *
 */

public class TokenMatch extends PartialTokenMatch
{
	private final Integer sourcePropertyPosition;
	private final Integer destinationPropertyPosition;

	public TokenMatch(final MatchStrength strength, final Integer sourcePropertyPosition, final Integer destinationPropertyPosition,
					  final Integer sourceTokenPosition, final Integer destinationTokenPosition) {
		super(strength, sourceTokenPosition, destinationTokenPosition);
		this.sourcePropertyPosition =  sourcePropertyPosition;
		this.destinationPropertyPosition = destinationPropertyPosition;
	}

	public Integer getSourcePropertyPosition()
	{
		return sourcePropertyPosition;
	}

	public Integer getDestinationPropertyPosition()
	{
		return destinationPropertyPosition;
	}

	@Override
	public boolean equals(final Object o)
	{
		return EqualsBuilder.reflectionEquals(this, o);
	}

	@Override
	public int hashCode()
	{
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public String toString()
	{
		return "TokenMatch{" +
				"strength="+getStrength()+
				", sourcePropertyPosition=" + sourcePropertyPosition +
				", destinationPropertyPosition=" + destinationPropertyPosition +
				", sourceTokenPosition=" + getSourceTokenPosition() +
				", destinationTokenPosition=" + getDestinationTokenPosition() +
				'}';
	}
}
