package net.projectmonkey.object.mapper.construction;

import net.projectmonkey.object.mapper.analysis.cache.TypePair;
import net.projectmonkey.object.mapper.analysis.result.PropertyConfiguration;
import net.projectmonkey.object.mapper.analysis.result.PropertyPathElement;
import net.projectmonkey.object.mapper.annotations.group.Group;
import net.projectmonkey.object.mapper.annotations.group.Groups;
import net.projectmonkey.object.mapper.util.TypeResolver;
import net.projectmonkey.object.mapper.util.Types;

import java.lang.reflect.Type;
import java.lang.reflect.TypeVariable;
import java.util.*;

import static net.projectmonkey.object.mapper.construction.type.GenericTypeUtils.TypeAndClass;

/*
 *
 *  * Copyright 2012 the original author or authors.
 *  *
 *  * Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  *      http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  * limitations under the License.
 *
 */

/**
 * @author Andy Moody
 */
public final class ElementPopulationContext<SourceType, DestinationType> extends RootPopulationContext<SourceType, DestinationType>
{
	private Type destinationGenericType;

	public ElementPopulationContext(final SourceType source, TypeAndClass destinationType, PopulationContext parentContext)
	{
		super(source, (Class<DestinationType>) destinationType.getClazz());
		addDestinationTypeArguments(parentContext.getDestinationTypeArguments());
		this.destinationGenericType = destinationType.getType();
	}

	@Override
	public Type getDestinationGenericType()
	{
		return destinationGenericType;
	}

}
