package net.projectmonkey.object.mapper.util;

/*
 *
 *  * Copyright 2012 the original author or authors.
 *  *
 *  * Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  *      http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  * limitations under the License.
 *
 */

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @author Andy Moody
 */
public class MapUtil
{

	public static <S, T> void addToMap(Map<S, List<T>> map, S key, T value)
	{
		initValueForKey(map, key);
		map.get(key).add(value);
	}

	public static <S, T> void addAllToMap(Map<S, List<T>> map, S key, List<T> value)
	{
		initValueForKey(map, key);
		map.get(key).addAll(value);
	}

	private static <S, T> void initValueForKey(final Map<S, List<T>> map, final S key)
	{
		if(!map.containsKey(key))
		{
			map.put(key, new ArrayList<T>());
		}
	}

	public static boolean hasElements(final Map map)
	{
		return map != null && !map.isEmpty();
	}
}
